import { FormControl, FormGroup, FormBuilder, FormArray } from '@angular/forms';
import { classToClass, plainToClass } from 'class-transformer';
import 'reflect-metadata';
import lodash from 'lodash.clonedeep';
import { Validator, getMetadataStorage, ValidationTypes, validateSync } from 'class-validator';
import safeStringify from 'fast-safe-stringify';
import { Observable, BehaviorSubject, Subject } from 'rxjs';
import { distinctUntilChanged, tap } from 'rxjs/operators';
import lodash$1 from 'lodash.mergewith';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/dictionary.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 * @template T
 */
function Dictionary() { }

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/dynamic-form-group-config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DynamicFormGroupConfig() { }
if (false) {
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.validator;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.asyncValidator;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.validators;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.asyncValidators;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.updateOn;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.customValidatorOptions;
}
/**
 * @param {?} options
 * @return {?}
 */
function isDynamicFormGroupConfig(options) {
    return options && !!options['customValidatorOptions'];
}
/**
 * @param {?} options
 * @return {?}
 */
function isLegacyOrOpts(options) {
    return options && (!!options['validator'] || !!options['asyncValidator']);
}
/**
 * @param {?} options
 * @return {?}
 */
function isAbstractControlOptions(options) {
    return options && (!!options.validators || !!options.asyncValidators || !!options.updateOn);
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/dynamic-form-group-field.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DynamicFormGroupField() { }
if (false) {
    /** @type {?} */
    DynamicFormGroupField.prototype.data;
    /** @type {?} */
    DynamicFormGroupField.prototype.validationFunctions;
    /** @type {?} */
    DynamicFormGroupField.prototype.validationDefinitions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/error-property-name.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/form-model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/short-validation-errors.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ShortValidationErrors() { }

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/validator-function-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ValidatorFunctionSyncType() { }
if (false) {
    /** @type {?} */
    ValidatorFunctionSyncType.prototype.type;
    /** @type {?} */
    ValidatorFunctionSyncType.prototype.validator;
}
/**
 * @record
 */
function ValidatorFunctionAsyncType() { }
if (false) {
    /** @type {?} */
    ValidatorFunctionAsyncType.prototype.type;
    /** @type {?} */
    ValidatorFunctionAsyncType.prototype.validator;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/validators/forever-invalid.validator.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} c
 * @return {?}
 */
function foreverInvalid(c) {
    return {
        foreverInvalid: {
            valid: false,
        },
    };
}
/** @type {?} */
const FOREVER_INVALID_NAME = 'foreverInvalid';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/dynamic-form-control.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFormControl extends FormControl {
    /**
     * @param {?} name
     * @param {?} fieldDefinition
     */
    constructor(name, fieldDefinition) {
        super(fieldDefinition.data instanceof Observable ? null : fieldDefinition.data, fieldDefinition.validationFunctions
            .filter((/**
         * @param {?} func
         * @return {?}
         */
        (func) => func.type === 'sync'))
            .map((/**
         * @param {?} func
         * @return {?}
         */
        (func) => (/** @type {?} */ (func.validator)))), fieldDefinition.validationFunctions
            .filter((/**
         * @param {?} func
         * @return {?}
         */
        (func) => func.type === 'async'))
            .map((/**
         * @param {?} func
         * @return {?}
         */
        (func) => (/** @type {?} */ (func.validator)))));
        this.controlName = name;
        this.validationDefinitions = fieldDefinition.validationDefinitions;
    }
}
if (false) {
    /** @type {?} */
    DynamicFormControl.prototype.controlName;
    /** @type {?} */
    DynamicFormControl.prototype.validationDefinitions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/dynamic-form-group-helpers.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */

/** @type {?} */

/**
 * @param {?} errors
 * @return {?}
 */
function transformValidationErrors(errors) {
    /** @type {?} */
    const customErrors = {};
    errors.forEach((/**
     * @param {?} error
     * @return {?}
     */
    (error) => {
        if (error && error.constraints !== undefined) {
            Object.keys(error.constraints).forEach((/**
             * @param {?} key
             * @return {?}
             */
            (key) => {
                if (!customErrors[error.property]) {
                    customErrors[error.property] = [];
                }
                if (error.constraints && ((/** @type {?} */ (customErrors[error.property]))).indexOf(error.constraints[key]) === -1) {
                    ((/** @type {?} */ (customErrors[error.property]))).push(error.constraints[key]);
                }
            }));
        }
        if (error.children !== undefined && error.children.length) {
            customErrors[error.property] = transformValidationErrors(error.children);
        }
    }));
    return customErrors;
}
/**
 * @param {?=} externalErrors
 * @param {?=} validationErrors
 * @return {?}
 */
function mergeErrors(externalErrors, validationErrors) {
    /** @type {?} */
    const clonedExternalErrors = lodash(externalErrors);
    return lodash$1(clonedExternalErrors, validationErrors, (/**
     * @param {?} objValue
     * @param {?} srcValue
     * @return {?}
     */
    (objValue, srcValue) => {
        if (canMerge()) {
            return objValue.concat(srcValue);
        }
        /**
         * @return {?}
         */
        function canMerge() {
            return (Array.isArray(objValue) && Array.isArray(srcValue) && !objValue.find((/**
             * @param {?} objItem
             * @return {?}
             */
            (objItem) => srcValue.includes(objItem))));
        }
    }));
}

/** @type {?} */

/** @type {?} */
const validator = new Validator();
/**
 * @template TModel
 */
class DynamicFormGroup extends FormGroup {
    /**
     * @param {?} factoryModel
     * @param {?=} fields
     * @param {?=} validatorOrOpts
     * @param {?=} asyncValidator
     */
    constructor(factoryModel, fields, validatorOrOpts, asyncValidator) {
        super({}, validatorOrOpts, asyncValidator);
        this.factoryModel = factoryModel;
        this.fields = fields;
        this.nativeValidateErrors = new BehaviorSubject({});
        this.customValidateErrors = new BehaviorSubject({});
        this.objectChange = new Subject();
        this._fb = new FormBuilder();
        /*
        const classValidators = DynamicFormGroup.getClassValidators<TModel>(
          this.factoryModel,
          this.fields,
          this.defaultValidatorOptions
        );
        const formGroup = this._fb.group(
          classValidators
        );
        Object.keys(formGroup.controls).forEach(key => {
          this.addControl(key, formGroup.controls[key]);
        });
        this.valueChanges.subscribe(data => {
          this.validate(
            undefined,
            this.defaultValidatorOptions
          );
        });*/
        this.formFields = this.onlyFields(fields);
    }
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    subscribeToValueChanges(externalErrors, validatorOptions) {
        if (!this.valueChangesSubscription) {
            this.valueChangesSubscription = this.valueChanges
                .pipe(distinctUntilChanged(), tap((/**
             * @return {?}
             */
            () => this.validate(externalErrors, validatorOptions))))
                .subscribe({
                error: (/**
                 * @param {?} err
                 * @return {?}
                 */
                (err) => {
                    throw err;
                }),
            });
        }
    }
    // Getters & Setters
    /**
     * @param {?} externalErrors
     * @return {?}
     */
    set externalErrors(externalErrors) {
        this._externalErrors = externalErrors;
        this.validate();
    }
    /**
     * @return {?}
     */
    get externalErrors() {
        return this._externalErrors;
    }
    /**
     * @param {?} validatorOptions
     * @return {?}
     */
    set validatorOptions(validatorOptions) {
        this._validatorOptions = validatorOptions;
        this.validate();
    }
    /**
     * @return {?}
     */
    get validatorOptions() {
        return this._validatorOptions;
    }
    /**
     * @param {?} object
     * @return {?}
     */
    set object(object) {
        this.setObject(object);
    }
    /**
     * @return {?}
     */
    get object() {
        return this.getObject();
    }
    /**
     * @deprecated
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    validateAsync(externalErrors, validatorOptions) {
        return Promise.resolve(this.validate(externalErrors, validatorOptions));
    }
    // Public API
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    validate(externalErrors, validatorOptions) {
        if (externalErrors === undefined) {
            externalErrors = lodash(this._externalErrors);
        }
        if (validatorOptions === undefined) {
            validatorOptions = lodash(this._validatorOptions);
        }
        /** @type {?} */
        const dataToValidate = this.object;
        /** @type {?} */
        const validationErrors = getValidateErrors(this, dataToValidate, validatorOptions);
        if (!externalErrors) {
            externalErrors = {};
        }
        /** @type {?} */
        const allErrors = mergeErrors(externalErrors, validationErrors);
        /** @type {?} */
        const allErrorsKeys = Object.keys(allErrors);
        this.markAsInvalidForExternalErrors(externalErrors);
        this.setCustomErrors(allErrors);
        // todo: refactor, invalidate form if exists any allErrors
        /** @type {?} */
        let usedForeverInvalid = false;
        if (!allErrorsKeys.find((/**
         * @param {?} key
         * @return {?}
         */
        (key) => key !== FOREVER_INVALID_NAME)) && this.get(FOREVER_INVALID_NAME)) {
            this.removeControl(FOREVER_INVALID_NAME);
            usedForeverInvalid = true;
        }
        if (this.valid && allErrorsKeys.length > 0 && !this.get(FOREVER_INVALID_NAME)) {
            this.addControl(FOREVER_INVALID_NAME, new FormControl('', [foreverInvalid]));
            usedForeverInvalid = true;
        }
        if (usedForeverInvalid) {
            this.updateValueAndValidity({
                onlySelf: true,
                emitEvent: false,
            });
        }
    }
    /**
     * @param {?} allErrors
     * @return {?}
     */
    setCustomErrors(allErrors) {
        this.formErrors = allErrors;
        this.customValidateErrors.next(this.formErrors);
        this.nativeValidateErrors.next(this.collectErrors(this));
    }
    /**
     * @private
     * @param {?} control
     * @param {?=} isRoot
     * @return {?}
     */
    collectErrors(control, isRoot = true) {
        if (control.controls) {
            return Object.assign(Object.assign({}, (isRoot ? this.errors : {})), Object.entries(control.controls).reduce((/**
             * @param {?} acc
             * @param {?} __1
             * @return {?}
             */
            (acc, [key, childControl]) => {
                /** @type {?} */
                const childErrors = this.collectErrors(childControl, false);
                if (childErrors && Object.keys(childErrors).length > 0) {
                    acc = Object.assign(Object.assign({}, acc), { [key]: Object.assign(Object.assign({}, (acc && acc[key] ? acc[key] : {})), childErrors) });
                }
                return acc;
            }), {}));
        }
        else {
            return control.errors;
        }
    }
    /**
     * @return {?}
     */
    validateAllFormFields() {
        /** @type {?} */
        let control;
        /** @type {?} */
        let formArrayControlsLength;
        Object.keys(this.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            control = this.get(field);
            // Control
            if (control instanceof FormControl) {
                control.markAsTouched({ onlySelf: true });
            }
            // Group: recursive
            else if (control instanceof DynamicFormGroup) {
                control.validateAllFormFields();
            }
            // Array
            else if (control instanceof FormArray) {
                formArrayControlsLength = ((/** @type {?} */ (control))).controls.length;
                for (let i = 0; i < formArrayControlsLength; i++) {
                    // Control in Array
                    if (((/** @type {?} */ (control))).controls[i] instanceof FormControl) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsTouched({ onlySelf: true });
                    }
                    // Group in Array: recursive
                    else if (((/** @type {?} */ (control))).controls[i] instanceof DynamicFormGroup) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).validateAllFormFields();
                    }
                }
            }
        }));
        formArrayControlsLength = null;
        control = null;
    }
    /**
     * @return {?}
     */
    resetValidateAllFormFields() {
        this.markAsInvalidForExternalErrors({});
        /** @type {?} */
        let control;
        Object.keys(this.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            control = this.get(field);
            // Control
            if (control instanceof FormControl) {
                control.setErrors(null, { emitEvent: false });
                control.markAsUntouched({ onlySelf: true });
                control.markAsPristine({ onlySelf: true });
            }
            // Group: recursive
            else if (control instanceof DynamicFormGroup) {
                control.resetValidateAllFormFields();
            }
            // Array
            else if (control instanceof FormArray) {
                /** @type {?} */
                const formArrayControlsLength = ((/** @type {?} */ (control))).controls.length;
                for (let i = 0; i < formArrayControlsLength; i++) {
                    // Control in Array
                    if (((/** @type {?} */ (control))).controls[i] instanceof FormControl) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).setErrors(null, { emitEvent: false });
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsUntouched({ onlySelf: true });
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsPristine({ onlySelf: true });
                    }
                    // Group in Array: recursive
                    else if (((/** @type {?} */ (control))).controls[i] instanceof DynamicFormGroup) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).resetValidateAllFormFields();
                    }
                }
            }
        }));
        control = null;
        this.setCustomErrors({});
    }
    /**
     * @template TClassModel
     * @param {?} object
     * @return {?}
     */
    classToClass(object) {
        return classToClass(object, { ignoreDecorators: true });
    }
    /**
     * @template TClassModel, Object
     * @param {?} cls
     * @param {?} plain
     * @return {?}
     */
    plainToClass(cls, plain) {
        return plainToClass(cls, plain, { ignoreDecorators: true });
    }
    /**
     * @deprecated
     * @param {?} externalErrors
     * @return {?}
     */
    setExternalErrorsAsync(externalErrors) {
        this.setExternalErrors(externalErrors);
        return Promise.resolve();
    }
    /**
     * @param {?} externalErrors
     * @return {?}
     */
    setExternalErrors(externalErrors) {
        this._externalErrors = externalErrors;
        return this.validate();
    }
    /**
     * @return {?}
     */
    getExternalErrors() {
        return this._externalErrors;
    }
    /**
     * @deprecated
     * @return {?}
     */
    clearExternalErrorsAsync() {
        this.setExternalErrors({});
        return Promise.resolve();
    }
    /**
     * @return {?}
     */
    clearExternalErrors() {
        this.setExternalErrors({});
    }
    /**
     * @param {?=} validatorOptions
     * @return {?}
     */
    setValidatorOptions(validatorOptions) {
        this._validatorOptions = (/** @type {?} */ (validatorOptions));
        this.validate();
    }
    /**
     * @return {?}
     */
    getValidatorOptions() {
        return this._validatorOptions;
    }
    // Helpers
    /**
     * @private
     * @param {?=} fields
     * @return {?}
     */
    onlyFields(fields) {
        /** @type {?} */
        const newFields = {};
        if (fields !== undefined) {
            Object.keys(fields).forEach((/**
             * @param {?} key
             * @return {?}
             */
            (key) => {
                if (fields[key] instanceof DynamicFormGroup) {
                    // Group: recursive
                    newFields[key] = this.onlyFields(((/** @type {?} */ (fields[key]))).formFields);
                }
                else {
                    // Array
                    if (fields[key] instanceof FormArray) {
                        if (((/** @type {?} */ (fields[key]))).controls[0] instanceof DynamicFormGroup) {
                            // Group within Array: recursive
                            newFields[key] = this.onlyFields(((/** @type {?} */ (((/** @type {?} */ (fields[key]))).controls[0]))).formFields);
                        }
                        else {
                            // Control within Array
                            newFields[key] = ((/** @type {?} */ (fields[key]))).controls[0].value;
                        }
                    }
                    else {
                        // Handle Control
                        newFields[key] = fields[key];
                    }
                }
            }));
        }
        return newFields;
    }
    /**
     * @private
     * @param {?} errors
     * @param {?=} controls
     * @return {?}
     */
    markAsInvalidForExternalErrors(errors, controls) {
        /** @type {?} */
        const currentControls = controls ? controls : this.controls;
        Object.keys(currentControls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        (field) => {
            /** @type {?} */
            const control = currentControls[field];
            // Control
            if (control instanceof FormControl) {
                if (errors && errors[field]) {
                    control.setErrors({ externalError: true });
                }
                else {
                    if (control.errors && control.errors.externalError === true) {
                        control.setErrors(null);
                    }
                }
            }
            // Group
            else if (control instanceof DynamicFormGroup) {
                control.markAsInvalidForExternalErrors(errors && errors[field] ? ((/** @type {?} */ (errors[field]))) : {});
            }
            // Array
            else if (control instanceof FormArray) {
                /** @type {?} */
                const formArrayControlsLength = ((/** @type {?} */ (control))).length;
                for (let i = 0; i < formArrayControlsLength; i++) {
                    // Control in Array
                    if (control[i] instanceof FormControl) {
                        if (errors && errors[i] && errors[i][field]) {
                            control[i].setErrors({ externalError: true });
                        }
                        else if (control[i].errors && control[i].errors.externalError === true) {
                            control[i].setErrors(null);
                        }
                    }
                    // Group in Array
                    else if (control[i] instanceof DynamicFormGroup) {
                        control[i].markAsInvalidForExternalErrors(errors && errors[i] && errors[i][field] ? ((/** @type {?} */ (errors[i][field]))) : {});
                    }
                }
            }
        }));
    }
    /**
     * Recursively gets all values from the form controls and all sub form group and array controls and returns it as
     * an object
     * @private
     * @return {?}
     */
    getObject() {
        // Initialize the shape of the response
        /** @type {?} */
        const object = this._object
            ? this.classToClass(this._object)
            : this.factoryModel
                ? new this.factoryModel()
                : undefined;
        if (object !== undefined) {
            // Recursively get the value of all fields
            Object.keys(this.controls)
                .filter((/**
             * @param {?} name
             * @return {?}
             */
            (name) => name !== FOREVER_INVALID_NAME))
                .forEach((/**
             * @param {?} key
             * @return {?}
             */
            (key) => {
                // Handle Group
                if (this.controls[key] instanceof DynamicFormGroup) {
                    object[key] = ((/** @type {?} */ (this.controls[key]))).object;
                }
                // Handle Form Array
                else if (this.controls[key] instanceof FormArray) {
                    // Initialize value
                    object[key] = [];
                    /** @type {?} */
                    const formArrayControlsLength = ((/** @type {?} */ (this.controls[key]))).controls.length;
                    /** @type {?} */
                    let value;
                    for (let i = 0; i < formArrayControlsLength; i++) {
                        if (((/** @type {?} */ (this.controls[key]))).controls[i] instanceof DynamicFormGroup) {
                            // Recursively get object group
                            value = ((/** @type {?} */ (((/** @type {?} */ (this.controls[key]))).controls[i]))).object;
                        }
                        else {
                            value = ((/** @type {?} */ (this.controls[key]))).controls[i].value;
                        }
                        if (value && Object.keys(value).length > 0) {
                            object[key].push(value);
                        }
                    }
                    value = null;
                }
                // Handle Control
                else {
                    if (this.controls[key]) {
                        object[key] = this.controls[key].value;
                    }
                }
            }));
        }
        return this.factoryModel ? this.plainToClass(this.factoryModel, object) : (/** @type {?} */ (object));
    }
    /**
     * Sets the value of every control on the form and recursively sets the values of the controls
     * on all sub form groups
     *
     * @private
     * @param {?} object the data to assign to all controls of the form group and sub groups
     * @return {?}
     */
    setObject(object) {
        // console.time(String(object));
        if (object instanceof this.factoryModel) {
            this._object = this.classToClass(object); // Ensure correct type
        }
        else {
            this._object = this.plainToClass(this.factoryModel, (/** @type {?} */ (object))); // Convert to Model type
        }
        /** @type {?} */
        let newObject;
        /** @type {?} */
        let newValue;
        // Recursively set the value of all fields
        Object.keys(this.controls).forEach((/**
         * @param {?} key
         * @return {?}
         */
        (key) => {
            // Handle Group
            if (this.controls[key] instanceof DynamicFormGroup) {
                ((/** @type {?} */ (this.controls[key]))).setObject(this._object ? this._object[key] : {});
            }
            // Handle FormArray
            else if (this.controls[key] instanceof FormArray) {
                /** @type {?} */
                let objectArray = this._object ? this._object[key] : [];
                /** @type {?} */
                let formArray = (/** @type {?} */ (this.controls[key]));
                /** @type {?} */
                let isFormGroup = formArray.controls[0] instanceof DynamicFormGroup;
                /** @type {?} */
                let firstFormGroup = (/** @type {?} */ (formArray.controls[0]));
                /** @type {?} */
                let formControl = (/** @type {?} */ (formArray.controls[0]));
                // Clear FormArray while retaining the reference
                /** @type {?} */
                let objectArrayLength = objectArray.length;
                /** @type {?} */
                let dynamicFormGroup;
                /** @type {?} */
                let controlValue;
                /** @type {?} */
                let newFormControl;
                /** @type {?} */
                let classValidators;
                /** @type {?} */
                let formGroup;
                /** @type {?} */
                let formArrayLength = formArray.length;
                for (let i = 0; i < formArrayLength; i++) {
                    if (formArray.controls[i] instanceof DynamicFormGroup &&
                        ((/** @type {?} */ (formArray.controls[i]))).valueChangesSubscription) {
                        ((/** @type {?} */ (formArray.controls[i]))).valueChangesSubscription.unsubscribe();
                    }
                }
                while (formArrayLength !== 0) {
                    formArray.removeAt(0);
                    formArrayLength--;
                }
                formArrayLength = null;
                for (let i = 0; i < objectArrayLength; i++) {
                    if (isFormGroup) {
                        // Create FormGroup
                        dynamicFormGroup = new DynamicFormGroup(firstFormGroup.factoryModel, firstFormGroup.formFields);
                        dynamicFormGroup.setParent(formArray);
                        formGroup = this._fb.group(getClassValidators(firstFormGroup.factoryModel, firstFormGroup.formFields));
                        // Add all controls to the form group
                        Object.keys(formGroup.controls).forEach((/**
                         * @param {?} ctrlKey
                         * @return {?}
                         */
                        (ctrlKey) => {
                            dynamicFormGroup.addControl(ctrlKey, formGroup.controls[ctrlKey]);
                        }));
                        formArray.controls.push(dynamicFormGroup);
                    }
                    else {
                        // Create control
                        controlValue = this._object && objectArray && objectArray[i] ? objectArray[i] : undefined;
                        newFormControl = new FormControl(controlValue, formControl ? formControl.validator : undefined);
                        newFormControl.setParent(formArray);
                        // Add the control to the FormArray
                        formArray.controls.push(newFormControl);
                    }
                }
                /** @type {?} */
                let arrayLength = formArray.length;
                for (let i = 0; i < arrayLength; i++) {
                    if (isFormGroup) {
                        // Add a value change listener to the group. on change, validate
                        if (formArray.controls[i] instanceof DynamicFormGroup) {
                            // Recusrively set the object value
                            ((/** @type {?} */ (formArray.controls[i]))).object =
                                this._object && objectArray && objectArray[i] ? objectArray[i] : {};
                        }
                    }
                }
                for (let i = 0; i < arrayLength; i++) {
                    if (isFormGroup) {
                        // Add a value change listener to the group. on change, validate
                        if (formArray.controls[i] instanceof DynamicFormGroup) {
                            ((/** @type {?} */ (formArray.controls[i]))).subscribeToValueChanges(undefined, this._validatorOptions);
                        }
                    }
                }
                classValidators = null;
                formGroup = null;
                controlValue = null;
                newFormControl = null;
                dynamicFormGroup = null;
                objectArrayLength = null;
                arrayLength = null;
                objectArray = null;
                formArray = null;
                isFormGroup = null;
                firstFormGroup = null;
                formControl = null;
            }
            // Handle Control
            else {
                newObject = this._object ? this._object[key] : [];
                newValue = this._object && newObject ? newObject : undefined;
                if (this.controls[key].value !== newValue) {
                    this.controls[key].setValue(newValue);
                }
            }
        }));
        newValue = null;
        newObject = null;
        this.objectChange.next(this._object);
        // console.timeEnd(String(object));
    }
}
if (false) {
    /** @type {?} */
    DynamicFormGroup.prototype.nativeValidateErrors;
    /** @type {?} */
    DynamicFormGroup.prototype.customValidateErrors;
    /** @type {?} */
    DynamicFormGroup.prototype.formErrors;
    /** @type {?} */
    DynamicFormGroup.prototype.formFields;
    /** @type {?} */
    DynamicFormGroup.prototype.objectChange;
    /** @type {?} */
    DynamicFormGroup.prototype.valueChangesSubscription;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._object;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._externalErrors;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._validatorOptions;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._fb;
    /** @type {?} */
    DynamicFormGroup.prototype.factoryModel;
    /** @type {?} */
    DynamicFormGroup.prototype.fields;
}
/**
 * @template TModel
 * @param {?} factoryModel
 * @param {?=} fields
 * @param {?=} validatorOptions
 * @return {?}
 */
function getClassValidators(factoryModel, fields, validatorOptions) {
    // console.time(String(factoryModel));
    // Get the validation rules from the object decorators
    /** @type {?} */
    let allValidationMetadatas = getMetadataStorage().getTargetValidationMetadatas(factoryModel, '');
    // Get the validation rules for the validation group: https://github.com/typestack/class-validator#validation-groups
    /** @type {?} */
    let validationGroupMetadatas = getMetadataStorage().getTargetValidationMetadatas(factoryModel, '', validatorOptions && validatorOptions.groups ? validatorOptions.groups : undefined);
    /** @type {?} */
    const formGroupFields = {};
    // Loop through all fields in the form definition
    if (fields) {
        /** @type {?} */
        let conditionalValidations;
        /** @type {?} */
        let allNestedValidations;
        /** @type {?} */
        let nestedGroupValidations;
        /** @type {?} */
        let fieldDefinition;
        /** @type {?} */
        let dynamicValidate;
        /** @type {?} */
        let customValidation;
        /** @type {?} */
        let objectToValidate;
        /** @type {?} */
        let nestedValidate;
        Object.keys(fields)
            .filter((/**
         * @param {?} key
         * @return {?}
         */
        (key) => key.indexOf('__') !== 0))
            .forEach((/**
         * @param {?} fieldName
         * @return {?}
         */
        (fieldName) => {
            // Conditional Validation for the field
            conditionalValidations = [];
            validationGroupMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            (validationMetadata) => {
                if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.conditional.type)) {
                    conditionalValidations.push(validationMetadata);
                }
            }));
            // All Nested Validation for the field
            allNestedValidations = [];
            allValidationMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            (validationMetadata) => {
                if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.nested.type)) {
                    allNestedValidations.push(validationMetadata);
                }
            }));
            // Nested Validation for the field for the requested class-validator group
            nestedGroupValidations = [];
            validationGroupMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            (validationMetadata) => {
                if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.nested.type)) {
                    nestedGroupValidations.push(validationMetadata);
                }
            }));
            fieldDefinition = {
                data: formGroupFields[fieldName] || undefined,
                validationFunctions: [],
                validationDefinitions: [],
            };
            if (fieldDefinition.data === undefined) {
                fieldDefinition.data = fields[fieldName];
            }
            // TRY LINK EXISTS NATIVE VALIDATIONS, UNSTABLE !!!
            if (Array.isArray(fieldDefinition.data) &&
                fieldDefinition.data.length > 1 &&
                fieldDefinition.data.find((/**
                 * @param {?} validationFunction
                 * @param {?} index
                 * @return {?}
                 */
                (validationFunction, index) => index > 0 && typeof validationFunction === 'function'))) {
                fieldDefinition.data
                    .filter((/**
                 * @param {?} validationFunction
                 * @param {?} index
                 * @return {?}
                 */
                (validationFunction, index) => index > 0 && typeof validationFunction === 'function'))
                    .forEach((/**
                 * @param {?} validationFunction
                 * @return {?}
                 */
                (validationFunction) => fieldDefinition.validationFunctions.push({ type: 'sync', validator: validationFunction })));
                fieldDefinition.data = fieldDefinition.data[0];
            }
            validationGroupMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            (validationMetadata) => {
                if (validationMetadata.propertyName === fieldName &&
                    validationMetadata.type !== ValidationKeys.conditional.type) {
                    // Add all validation to the field except the @NestedValidation definition as
                    // being part of the form would imply it is validated if any other rules are present
                    if (validationMetadata.type !== ValidationKeys.nested.type) {
                        fieldDefinition.validationDefinitions.push(validationMetadata);
                    }
                    Object.keys(ValidationTypes).forEach((/**
                     * @param {?} typeKey
                     * @return {?}
                     */
                    (typeKey) => {
                        if (ValidationTypes.hasOwnProperty(typeKey)) {
                            // Handle Nested Validation
                            if (checkWithAllNestedValidations(allNestedValidations, nestedGroupValidations, fieldName)) {
                                if (isNestedValidate(validationMetadata, typeKey)) {
                                    objectToValidate =
                                        fields[fieldName] instanceof DynamicFormGroup ? fields[fieldName].object : undefined;
                                    nestedValidate = createNestedValidate(fieldName, objectToValidate, validationMetadata);
                                    setFieldData(fieldName, fieldDefinition, nestedValidate);
                                    objectToValidate = null;
                                    nestedValidate = null;
                                }
                            }
                            // Handle Custom Validation
                            if (isCustomValidate(validationMetadata, typeKey)) {
                                customValidation = createCustomValidation(fieldName, validationMetadata);
                                setFieldData(fieldName, fieldDefinition, customValidation);
                                customValidation = null;
                            }
                            // Handle remaining validation
                            if (isDynamicValidate(validationMetadata, typeKey)) {
                                dynamicValidate = createDynamicValidate(fieldName, validationMetadata, conditionalValidations);
                                setFieldData(fieldName, fieldDefinition, dynamicValidate);
                                dynamicValidate = null;
                            }
                        }
                    }));
                }
            }));
            // Convert to a structure, angular understands
            if (fieldDefinition.data instanceof DynamicFormGroup || fieldDefinition.data instanceof FormArray) {
                formGroupFields[fieldName] = fieldDefinition.data;
            }
            else {
                formGroupFields[fieldName] = new DynamicFormControl(fieldName, fieldDefinition);
            }
        }));
        dynamicValidate = null;
        customValidation = null;
        objectToValidate = null;
        nestedValidate = null;
        conditionalValidations = null;
        allNestedValidations = null;
        nestedGroupValidations = null;
        fieldDefinition = null;
    }
    allValidationMetadatas = null;
    validationGroupMetadatas = null;
    // console.timeEnd(String(factoryModel));
    return formGroupFields;
    // ******************************************************************************************
    // Local Helper functions to help make the main code more readable
    //
    /**
     * @param {?} fieldName
     * @param {?} objectToValidate
     * @param {?} validationMetadata
     * @return {?}
     */
    function createNestedValidate(fieldName, objectToValidate, validationMetadata) {
        return {
            type: 'sync',
            validator: (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                let parent = control.parent;
                /** @type {?} */
                let validateErrors = (parent &&
                    parent.value &&
                    getValidateErrors(parent, objectToValidate !== undefined ? objectToValidate : control.value, validatorOptions)) ||
                    {};
                /** @type {?} */
                let validateState = Object.keys(validateErrors).length === 0;
                /** @type {?} */
                const result = getIsValidResult(validateState, validationMetadata, 'nestedValidate');
                parent = null;
                validateErrors = null;
                validateState = null;
                return result;
            }),
        };
    }
    /**
     * @param {?} fieldName
     * @param {?} validationMetadata
     * @param {?} conditionalValidations
     * @return {?}
     */
    function createDynamicValidate(fieldName, validationMetadata, conditionalValidations) {
        return {
            type: 'sync',
            validator: (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                if (!control) {
                    return null;
                }
                /** @type {?} */
                let validateErrors = setObjectValueAndGetValidationErrors(fieldName, control, validatorOptions);
                /** @type {?} */
                let validateState = getAllErrors(validateErrors, fieldName).length === 0;
                /** @type {?} */
                const result = getIsValidResult(validateState, validationMetadata, 'dynamicValidate');
                validateErrors = null;
                validateState = null;
                return result;
            }),
        };
    }
    /**
     * @param {?} fieldName
     * @param {?} validationMetadata
     * @return {?}
     */
    function createCustomValidation(fieldName, validationMetadata) {
        return {
            type: 'sync',
            validator: (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                let validateErrors = setObjectValueAndGetValidationErrors(fieldName, control, validatorOptions);
                /** @type {?} */
                let validateState = validateErrors && validateErrors[fieldName] ? false : true;
                /** @type {?} */
                const result = getIsValidResult(validateState, validationMetadata, 'customValidation');
                validateErrors = null;
                validateState = null;
                return result;
            }),
        };
    }
    /**
     * @param {?} allNestedValidations
     * @param {?} nestedValidations
     * @param {?} key
     * @return {?}
     */
    function checkWithAllNestedValidations(allNestedValidations, nestedValidations, key) {
        /** @type {?} */
        const allNestedValidationsLength = allNestedValidations.length;
        /** @type {?} */
        const nestedValidationsLength = nestedValidations.length;
        return (allNestedValidationsLength === nestedValidationsLength ||
            (((fields && fields[key] instanceof DynamicFormGroup) || (fields && fields[key] instanceof FormArray)) &&
                allNestedValidationsLength > 0 &&
                nestedValidationsLength === 0));
    }
    /**
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isDynamicValidate(validationMetadata, typeKey) {
        return validationMetadata.type === ValidationTypes[typeKey] && validator[validationMetadata.type] !== undefined;
    }
    /**
     * marked with \@Validate(...)
     * https://github.com/typestack/class-validator#custom-validation-classes
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isCustomValidate(validationMetadata, typeKey) {
        return (isNotPropertyValidation(validationMetadata, typeKey) &&
            validationMetadata.type === ValidationKeys.custom.type &&
            typeKey === ValidationKeys.custom.typeKey);
    }
    /**
     * marked with \@ValidateNested()
     * https://github.com/typestack/class-validator#validating-nested-objects
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isNestedValidate(validationMetadata, typeKey) {
        return (isNotPropertyValidation(validationMetadata, typeKey) &&
            validationMetadata.type === ValidationKeys.nested.type &&
            typeKey === ValidationKeys.nested.typeKey);
    }
    /**
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isNotPropertyValidation(validationMetadata, typeKey) {
        return validationMetadata.type === ValidationTypes[typeKey] && validator[validationMetadata.type] === undefined;
    }
    /**
     * @param {?} fieldName
     * @param {?} fieldDefinition
     * @param {?} validationFunction
     * @return {?}
     */
    function setFieldData(fieldName, fieldDefinition, validationFunction) {
        /* todo: maybe not need, if enable this code, experemental mode not work
        if (fields[fieldName] instanceof DynamicFormGroup) {
          fields[fieldName].object = fields[fieldName].fields;
        }*/
        // Fill field data if empty
        if (fieldDefinition.data === undefined) {
            fieldDefinition.data = fields && fields[fieldName];
        }
        fieldDefinition.validationFunctions.push(validationFunction);
    }
    /**
     * @param {?} validateErrors
     * @param {?} fieldName
     * @return {?}
     */
    function getAllErrors(validateErrors, fieldName) {
        return Object.keys(validateErrors).filter((/**
         * @param {?} key
         * @return {?}
         */
        (key) => 
        // Check for nested/child errors
        validateErrors[key][fieldName] || validateErrors[fieldName]));
    }
}
// ***************************************************************
// Global Helper functions
//
/**
 * @param {?} validationMetadata
 * @param {?} fieldName
 * @param {?} validationMetadataType
 * @return {?}
 */
function isPropertyValidatorOfType(validationMetadata, fieldName, validationMetadataType) {
    return validationMetadata.propertyName === fieldName && validationMetadata.type === validationMetadataType;
}
/**
 * @param {?} fieldName
 * @param {?} control
 * @param {?=} validatorOptions
 * @return {?}
 */
function setObjectValueAndGetValidationErrors(fieldName, control, validatorOptions) {
    /** @type {?} */
    let parent = control.parent instanceof DynamicFormGroup
        ? ((/** @type {?} */ (control.parent)))
        : control.parent
            ? control.parent
            : null;
    /** @type {?} */
    let object = control.parent instanceof DynamicFormGroup
        ? ((/** @type {?} */ (control.parent))).object
        : control.parent
            ? control.parent.value
            : {};
    if (object) {
        object[fieldName] = control.value;
    }
    /** @type {?} */
    const result = (parent && parent.value && getValidateErrors(parent, object, validatorOptions)) || {};
    parent = null;
    object = null;
    return result;
}
/**
 * @template T
 * @param {?} control
 * @param {?} dataToValidate
 * @param {?=} validatorOptions
 * @return {?}
 */
function getValidateErrors(control, dataToValidate, validatorOptions) {
    /** @type {?} */
    let validateKey = safeStringify({ dataToValidate, validatorOptions });
    /** @type {?} */
    let ctrl = ((/** @type {?} */ (control))) || {};
    /** @type {?} */
    let validatedErrors;
    if (ctrl.__prevValidateKey === validateKey && ctrl.__prevValidateErrors !== undefined) {
        // console.log('CACHED', validateKey);
        validatedErrors = ctrl.__prevValidateErrors;
    }
    else {
        // console.log('NO CACHED', validateKey);
        validatedErrors = transformValidationErrors(validateSync(dataToValidate, validatorOptions));
        ctrl.__prevValidateErrors = validatedErrors;
        ctrl.__prevValidateKey = validateKey;
    }
    validateKey = null;
    ctrl = null;
    return validatedErrors;
}
/**
 * @param {?} isValid
 * @param {?} validationMetadata
 * @param {?} errorType
 * @return {?}
 */
function getIsValidResult(isValid, validationMetadata, errorType) {
    return isValid
        ? null
        : {
            [errorType]: {
                valid: false,
                type: validationMetadata.type,
            },
        };
}
/** @type {?} */
const ValidationKeys = {
    nested: {
        type: 'nestedValidation',
        typeKey: 'NESTED_VALIDATION',
    },
    conditional: {
        type: 'conditionalValidation',
    },
    custom: {
        type: 'customValidation',
        typeKey: 'CUSTOM_VALIDATION',
    },
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/dynamic-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFormBuilder extends FormBuilder {
    // ******************
    // Public API
    /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} controlsConfig
     * @param {?=} options
     * @return {?}
     */
    group(factoryModel, controlsConfig, options) {
        // console.time(factoryModel.toString());
        if (!controlsConfig && !options) {
            options = {};
        }
        // Process the group with the controlsConfig passed into extra instead. (What does this accomplish?)
        if (controlsConfig &&
            (isAbstractControlOptions(controlsConfig) ||
                isLegacyOrOpts(controlsConfig) ||
                isDynamicFormGroupConfig(controlsConfig)) &&
            !options) {
            return this.group(factoryModel, undefined, controlsConfig);
        }
        /** @type {?} */
        const extra = (/** @type {?} */ (options));
        /** @type {?} */
        let validators = null;
        /** @type {?} */
        let asyncValidators = null;
        /** @type {?} */
        let updateOn;
        if (extra != null) {
            if (isAbstractControlOptions(extra)) {
                // `extra` are `AbstractControlOptions`
                validators = extra.validators != null ? extra.validators : null;
                asyncValidators = extra.asyncValidators != null ? extra.asyncValidators : null;
                updateOn = extra.updateOn != null ? extra.updateOn : undefined;
            }
            if (isLegacyOrOpts(extra)) {
                // `extra` are legacy form group options
                validators = validators || [];
                if (extra.validator != null) {
                    validators.push(extra.validator);
                }
                asyncValidators = asyncValidators || [];
                if (extra.asyncValidator != null) {
                    asyncValidators.push(extra.asyncValidator);
                }
            }
            // Set default customValidatorOptions
            if (!isDynamicFormGroupConfig(extra)) {
                extra.customValidatorOptions = { validationError: { target: false } };
            }
        }
        /** @type {?} */
        let newControlsConfig;
        if (controlsConfig !== undefined) {
            newControlsConfig = (/** @type {?} */ (controlsConfig));
        }
        // experimental
        if (controlsConfig === undefined) {
            newControlsConfig = Object.assign({}, this.createEmptyObject(factoryModel));
            if (newControlsConfig !== undefined) {
                Object.keys(newControlsConfig).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                (key) => {
                    if (canCreateGroup() && newControlsConfig) {
                        // recursively create a dynamic group for the nested object
                        newControlsConfig[key] = this.group(newControlsConfig[key].constructor, undefined, Object.assign(Object.assign({}, (extra.customValidatorOptions ? { customValidatorOptions: extra.customValidatorOptions } : {})), { asyncValidators,
                            updateOn,
                            validators }));
                    }
                    else {
                        if (canCreateArray() && newControlsConfig) {
                            if (newControlsConfig[key][0].constructor) {
                                // recursively create an array with a group
                                newControlsConfig[key] = super.array(newControlsConfig[key].map((/**
                                 * @param {?} newControlsConfigItem
                                 * @return {?}
                                 */
                                (newControlsConfigItem) => this.group(newControlsConfigItem.constructor, undefined, Object.assign(Object.assign({}, (extra.customValidatorOptions ? { customValidatorOptions: extra.customValidatorOptions } : {})), { asyncValidators,
                                    updateOn,
                                    validators })))));
                            }
                            else {
                                // Create an array of form controls
                                newControlsConfig[key] = super.array(newControlsConfig[key].map((/**
                                 * @param {?} newControlsConfigItem
                                 * @return {?}
                                 */
                                (newControlsConfigItem) => this.control(newControlsConfigItem))));
                            }
                        }
                    }
                    /**
                     * @return {?}
                     */
                    function canCreateGroup() {
                        /** @type {?} */
                        const candidate = newControlsConfig && newControlsConfig[key];
                        return (candidate &&
                            !Array.isArray(candidate) &&
                            candidate.constructor &&
                            typeof candidate === 'object' &&
                            (candidate.length === undefined ||
                                (candidate.length !== undefined && Object.keys(candidate).length === candidate.length)));
                    }
                    /**
                     * @return {?}
                     */
                    function canCreateArray() {
                        if (Array.isArray(newControlsConfig && newControlsConfig[key]) === false) {
                            return false;
                        }
                        /** @type {?} */
                        const candidate = newControlsConfig && newControlsConfig[key][0];
                        return (candidate.constructor &&
                            typeof candidate === 'object' &&
                            (candidate.length === undefined ||
                                (candidate.length !== undefined && Object.keys(candidate).length === candidate.length)));
                    }
                }));
            }
        }
        // Remove empty
        validators = validators && validators.filter((/**
         * @param {?} validator
         * @return {?}
         */
        (validator) => validator));
        asyncValidators = asyncValidators && asyncValidators.filter((/**
         * @param {?} validator
         * @return {?}
         */
        (validator) => validator));
        // Create an Angular group from the top-level object
        /** @type {?} */
        let classValidators = getClassValidators(factoryModel, newControlsConfig, extra && extra.customValidatorOptions);
        /** @type {?} */
        let formGroup = super.group(classValidators, Object.assign(Object.assign(Object.assign({}, (asyncValidators || {})), (updateOn || {})), (validators || {})));
        // Initialize the resulting group
        /** @type {?} */
        const dynamicFormGroup = new DynamicFormGroup(factoryModel, newControlsConfig, {
            asyncValidators,
            updateOn,
            validators,
        });
        // Add all angular controls to the resulting dynamic group
        Object.keys(formGroup.controls).forEach((/**
         * @param {?} key
         * @return {?}
         */
        (key) => {
            dynamicFormGroup.addControl(key, formGroup.controls[key]);
        }));
        // Add a listener to the dynamic group for value changes; on change, execute validation
        dynamicFormGroup.subscribeToValueChanges(undefined, extra && extra.customValidatorOptions);
        classValidators = null;
        formGroup = null;
        // console.timeEnd(factoryModel.toString());
        return dynamicFormGroup;
    }
    // *******************
    // Helpers
    /**
     * Recursively creates an empty object from the data provided
     * @private
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} data
     * @return {?}
     */
    createEmptyObject(factoryModel, data = {}) {
        /** @type {?} */
        let modifed = false;
        /** @type {?} */
        let object = factoryModel ? plainToClass(factoryModel, data) : data;
        /** @type {?} */
        let fields = Object.keys(object);
        /** @type {?} */
        let objectFieldNameLength;
        /** @type {?} */
        let objectFieldName0;
        fields.forEach((/**
         * @param {?} fieldName
         * @return {?}
         */
        (fieldName) => {
            objectFieldNameLength = object[fieldName] && object[fieldName].length;
            if (objectFieldNameLength !== undefined) {
                objectFieldName0 = object[fieldName][0];
                if (objectFieldNameLength === 1 && Object.keys(objectFieldName0).length > 0 && objectFieldName0.constructor) {
                    object[fieldName] = [this.createEmptyObject(objectFieldName0.constructor)];
                }
                if (objectFieldNameLength === 0) {
                    data[fieldName] = [{}];
                    modifed = true;
                }
            }
            else {
                data[fieldName] = undefined;
            }
        }));
        if (modifed) {
            object = null;
            fields = null;
            return this.createEmptyObject(factoryModel, data);
        }
        fields = null;
        return object;
    }
}

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-dynamic-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DynamicFormBuilder, DynamicFormControl, DynamicFormGroup, FOREVER_INVALID_NAME, foreverInvalid, getClassValidators, isAbstractControlOptions, isDynamicFormGroupConfig, isLegacyOrOpts, mergeErrors, transformValidationErrors };
//# sourceMappingURL=ngx-dynamic-form-builder.js.map
