import { __extends, __assign, __read } from 'tslib';
import { FormControl, FormBuilder, FormArray, FormGroup } from '@angular/forms';
import { classToClass, plainToClass } from 'class-transformer';
import 'reflect-metadata';
import lodash from 'lodash.clonedeep';
import { Validator, getMetadataStorage, ValidationTypes, validateSync } from 'class-validator';
import safeStringify from 'fast-safe-stringify';
import { Observable, BehaviorSubject, Subject } from 'rxjs';
import { distinctUntilChanged, tap } from 'rxjs/operators';
import lodash$1 from 'lodash.mergewith';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/dictionary.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 * @template T
 */
function Dictionary() { }

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/dynamic-form-group-config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DynamicFormGroupConfig() { }
if (false) {
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.validator;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.asyncValidator;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.validators;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.asyncValidators;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.updateOn;
    /** @type {?|undefined} */
    DynamicFormGroupConfig.prototype.customValidatorOptions;
}
/**
 * @param {?} options
 * @return {?}
 */
function isDynamicFormGroupConfig(options) {
    return options && !!options['customValidatorOptions'];
}
/**
 * @param {?} options
 * @return {?}
 */
function isLegacyOrOpts(options) {
    return options && (!!options['validator'] || !!options['asyncValidator']);
}
/**
 * @param {?} options
 * @return {?}
 */
function isAbstractControlOptions(options) {
    return options && (!!options.validators || !!options.asyncValidators || !!options.updateOn);
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/dynamic-form-group-field.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function DynamicFormGroupField() { }
if (false) {
    /** @type {?} */
    DynamicFormGroupField.prototype.data;
    /** @type {?} */
    DynamicFormGroupField.prototype.validationFunctions;
    /** @type {?} */
    DynamicFormGroupField.prototype.validationDefinitions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/error-property-name.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/form-model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/short-validation-errors.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ShortValidationErrors() { }

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/validator-function-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ValidatorFunctionSyncType() { }
if (false) {
    /** @type {?} */
    ValidatorFunctionSyncType.prototype.type;
    /** @type {?} */
    ValidatorFunctionSyncType.prototype.validator;
}
/**
 * @record
 */
function ValidatorFunctionAsyncType() { }
if (false) {
    /** @type {?} */
    ValidatorFunctionAsyncType.prototype.type;
    /** @type {?} */
    ValidatorFunctionAsyncType.prototype.validator;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/validators/forever-invalid.validator.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} c
 * @return {?}
 */
function foreverInvalid(c) {
    return {
        foreverInvalid: {
            valid: false,
        },
    };
}
/** @type {?} */
var FOREVER_INVALID_NAME = 'foreverInvalid';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/dynamic-form-control.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DynamicFormControl = /** @class */ (function (_super) {
    __extends(DynamicFormControl, _super);
    function DynamicFormControl(name, fieldDefinition) {
        var _this = _super.call(this, fieldDefinition.data instanceof Observable ? null : fieldDefinition.data, fieldDefinition.validationFunctions
            .filter((/**
         * @param {?} func
         * @return {?}
         */
        function (func) { return func.type === 'sync'; }))
            .map((/**
         * @param {?} func
         * @return {?}
         */
        function (func) { return (/** @type {?} */ (func.validator)); })), fieldDefinition.validationFunctions
            .filter((/**
         * @param {?} func
         * @return {?}
         */
        function (func) { return func.type === 'async'; }))
            .map((/**
         * @param {?} func
         * @return {?}
         */
        function (func) { return (/** @type {?} */ (func.validator)); }))) || this;
        _this.controlName = name;
        _this.validationDefinitions = fieldDefinition.validationDefinitions;
        return _this;
    }
    return DynamicFormControl;
}(FormControl));
if (false) {
    /** @type {?} */
    DynamicFormControl.prototype.controlName;
    /** @type {?} */
    DynamicFormControl.prototype.validationDefinitions;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/dynamic-form-group-helpers.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */

/** @type {?} */

/**
 * @param {?} errors
 * @return {?}
 */
function transformValidationErrors(errors) {
    /** @type {?} */
    var customErrors = {};
    errors.forEach((/**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        if (error && error.constraints !== undefined) {
            Object.keys(error.constraints).forEach((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                if (!customErrors[error.property]) {
                    customErrors[error.property] = [];
                }
                if (error.constraints && ((/** @type {?} */ (customErrors[error.property]))).indexOf(error.constraints[key]) === -1) {
                    ((/** @type {?} */ (customErrors[error.property]))).push(error.constraints[key]);
                }
            }));
        }
        if (error.children !== undefined && error.children.length) {
            customErrors[error.property] = transformValidationErrors(error.children);
        }
    }));
    return customErrors;
}
/**
 * @param {?=} externalErrors
 * @param {?=} validationErrors
 * @return {?}
 */
function mergeErrors(externalErrors, validationErrors) {
    /** @type {?} */
    var clonedExternalErrors = lodash(externalErrors);
    return lodash$1(clonedExternalErrors, validationErrors, (/**
     * @param {?} objValue
     * @param {?} srcValue
     * @return {?}
     */
    function (objValue, srcValue) {
        if (canMerge()) {
            return objValue.concat(srcValue);
        }
        /**
         * @return {?}
         */
        function canMerge() {
            return (Array.isArray(objValue) && Array.isArray(srcValue) && !objValue.find((/**
             * @param {?} objItem
             * @return {?}
             */
            function (objItem) { return srcValue.includes(objItem); })));
        }
    }));
}

/** @type {?} */

/** @type {?} */
var validator = new Validator();
/**
 * @template TModel
 */
var  /**
 * @template TModel
 */
DynamicFormGroup = /** @class */ (function (_super) {
    __extends(DynamicFormGroup, _super);
    function DynamicFormGroup(factoryModel, fields, validatorOrOpts, asyncValidator) {
        var _this = _super.call(this, {}, validatorOrOpts, asyncValidator) || this;
        _this.factoryModel = factoryModel;
        _this.fields = fields;
        _this.nativeValidateErrors = new BehaviorSubject({});
        _this.customValidateErrors = new BehaviorSubject({});
        _this.objectChange = new Subject();
        _this._fb = new FormBuilder();
        /*
        const classValidators = DynamicFormGroup.getClassValidators<TModel>(
          this.factoryModel,
          this.fields,
          this.defaultValidatorOptions
        );
        const formGroup = this._fb.group(
          classValidators
        );
        Object.keys(formGroup.controls).forEach(key => {
          this.addControl(key, formGroup.controls[key]);
        });
        this.valueChanges.subscribe(data => {
          this.validate(
            undefined,
            this.defaultValidatorOptions
          );
        });*/
        _this.formFields = _this.onlyFields(fields);
        return _this;
    }
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.prototype.subscribeToValueChanges = /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (externalErrors, validatorOptions) {
        var _this = this;
        if (!this.valueChangesSubscription) {
            this.valueChangesSubscription = this.valueChanges
                .pipe(distinctUntilChanged(), tap((/**
             * @return {?}
             */
            function () { return _this.validate(externalErrors, validatorOptions); })))
                .subscribe({
                error: (/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) {
                    throw err;
                }),
            });
        }
    };
    Object.defineProperty(DynamicFormGroup.prototype, "externalErrors", {
        get: /**
         * @return {?}
         */
        function () {
            return this._externalErrors;
        },
        // Getters & Setters
        set: 
        // Getters & Setters
        /**
         * @param {?} externalErrors
         * @return {?}
         */
        function (externalErrors) {
            this._externalErrors = externalErrors;
            this.validate();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DynamicFormGroup.prototype, "validatorOptions", {
        get: /**
         * @return {?}
         */
        function () {
            return this._validatorOptions;
        },
        set: /**
         * @param {?} validatorOptions
         * @return {?}
         */
        function (validatorOptions) {
            this._validatorOptions = validatorOptions;
            this.validate();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DynamicFormGroup.prototype, "object", {
        get: /**
         * @return {?}
         */
        function () {
            return this.getObject();
        },
        set: /**
         * @param {?} object
         * @return {?}
         */
        function (object) {
            this.setObject(object);
        },
        enumerable: false,
        configurable: true
    });
    /**
     * @deprecated
     */
    /**
     * @deprecated
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.prototype.validateAsync = /**
     * @deprecated
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (externalErrors, validatorOptions) {
        return Promise.resolve(this.validate(externalErrors, validatorOptions));
    };
    // Public API
    // Public API
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.prototype.validate = 
    // Public API
    /**
     * @param {?=} externalErrors
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (externalErrors, validatorOptions) {
        if (externalErrors === undefined) {
            externalErrors = lodash(this._externalErrors);
        }
        if (validatorOptions === undefined) {
            validatorOptions = lodash(this._validatorOptions);
        }
        /** @type {?} */
        var dataToValidate = this.object;
        /** @type {?} */
        var validationErrors = getValidateErrors(this, dataToValidate, validatorOptions);
        if (!externalErrors) {
            externalErrors = {};
        }
        /** @type {?} */
        var allErrors = mergeErrors(externalErrors, validationErrors);
        /** @type {?} */
        var allErrorsKeys = Object.keys(allErrors);
        this.markAsInvalidForExternalErrors(externalErrors);
        this.setCustomErrors(allErrors);
        // todo: refactor, invalidate form if exists any allErrors
        /** @type {?} */
        var usedForeverInvalid = false;
        if (!allErrorsKeys.find((/**
         * @param {?} key
         * @return {?}
         */
        function (key) { return key !== FOREVER_INVALID_NAME; })) && this.get(FOREVER_INVALID_NAME)) {
            this.removeControl(FOREVER_INVALID_NAME);
            usedForeverInvalid = true;
        }
        if (this.valid && allErrorsKeys.length > 0 && !this.get(FOREVER_INVALID_NAME)) {
            this.addControl(FOREVER_INVALID_NAME, new FormControl('', [foreverInvalid]));
            usedForeverInvalid = true;
        }
        if (usedForeverInvalid) {
            this.updateValueAndValidity({
                onlySelf: true,
                emitEvent: false,
            });
        }
    };
    /**
     * @param {?} allErrors
     * @return {?}
     */
    DynamicFormGroup.prototype.setCustomErrors = /**
     * @param {?} allErrors
     * @return {?}
     */
    function (allErrors) {
        this.formErrors = allErrors;
        this.customValidateErrors.next(this.formErrors);
        this.nativeValidateErrors.next(this.collectErrors(this));
    };
    /**
     * @private
     * @param {?} control
     * @param {?=} isRoot
     * @return {?}
     */
    DynamicFormGroup.prototype.collectErrors = /**
     * @private
     * @param {?} control
     * @param {?=} isRoot
     * @return {?}
     */
    function (control, isRoot) {
        var _this = this;
        if (isRoot === void 0) { isRoot = true; }
        if (control.controls) {
            return __assign(__assign({}, (isRoot ? this.errors : {})), Object.entries(control.controls).reduce((/**
             * @param {?} acc
             * @param {?} __1
             * @return {?}
             */
            function (acc, _a) {
                var _b;
                var _c = __read(_a, 2), key = _c[0], childControl = _c[1];
                /** @type {?} */
                var childErrors = _this.collectErrors(childControl, false);
                if (childErrors && Object.keys(childErrors).length > 0) {
                    acc = __assign(__assign({}, acc), (_b = {}, _b[key] = __assign(__assign({}, (acc && acc[key] ? acc[key] : {})), childErrors), _b));
                }
                return acc;
            }), {}));
        }
        else {
            return control.errors;
        }
    };
    /**
     * @return {?}
     */
    DynamicFormGroup.prototype.validateAllFormFields = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var control;
        /** @type {?} */
        var formArrayControlsLength;
        Object.keys(this.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            control = _this.get(field);
            // Control
            if (control instanceof FormControl) {
                control.markAsTouched({ onlySelf: true });
            }
            // Group: recursive
            else if (control instanceof DynamicFormGroup) {
                control.validateAllFormFields();
            }
            // Array
            else if (control instanceof FormArray) {
                formArrayControlsLength = ((/** @type {?} */ (control))).controls.length;
                for (var i = 0; i < formArrayControlsLength; i++) {
                    // Control in Array
                    if (((/** @type {?} */ (control))).controls[i] instanceof FormControl) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsTouched({ onlySelf: true });
                    }
                    // Group in Array: recursive
                    else if (((/** @type {?} */ (control))).controls[i] instanceof DynamicFormGroup) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).validateAllFormFields();
                    }
                }
            }
        }));
        formArrayControlsLength = null;
        control = null;
    };
    /**
     * @return {?}
     */
    DynamicFormGroup.prototype.resetValidateAllFormFields = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.markAsInvalidForExternalErrors({});
        /** @type {?} */
        var control;
        Object.keys(this.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            control = _this.get(field);
            // Control
            if (control instanceof FormControl) {
                control.setErrors(null, { emitEvent: false });
                control.markAsUntouched({ onlySelf: true });
                control.markAsPristine({ onlySelf: true });
            }
            // Group: recursive
            else if (control instanceof DynamicFormGroup) {
                control.resetValidateAllFormFields();
            }
            // Array
            else if (control instanceof FormArray) {
                /** @type {?} */
                var formArrayControlsLength = ((/** @type {?} */ (control))).controls.length;
                for (var i = 0; i < formArrayControlsLength; i++) {
                    // Control in Array
                    if (((/** @type {?} */ (control))).controls[i] instanceof FormControl) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).setErrors(null, { emitEvent: false });
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsUntouched({ onlySelf: true });
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).markAsPristine({ onlySelf: true });
                    }
                    // Group in Array: recursive
                    else if (((/** @type {?} */ (control))).controls[i] instanceof DynamicFormGroup) {
                        ((/** @type {?} */ (((/** @type {?} */ (control))).controls[i]))).resetValidateAllFormFields();
                    }
                }
            }
        }));
        control = null;
        this.setCustomErrors({});
    };
    /**
     * @template TClassModel
     * @param {?} object
     * @return {?}
     */
    DynamicFormGroup.prototype.classToClass = /**
     * @template TClassModel
     * @param {?} object
     * @return {?}
     */
    function (object) {
        return classToClass(object, { ignoreDecorators: true });
    };
    /**
     * @template TClassModel, Object
     * @param {?} cls
     * @param {?} plain
     * @return {?}
     */
    DynamicFormGroup.prototype.plainToClass = /**
     * @template TClassModel, Object
     * @param {?} cls
     * @param {?} plain
     * @return {?}
     */
    function (cls, plain) {
        return plainToClass(cls, plain, { ignoreDecorators: true });
    };
    /**
     * @deprecated
     */
    /**
     * @deprecated
     * @param {?} externalErrors
     * @return {?}
     */
    DynamicFormGroup.prototype.setExternalErrorsAsync = /**
     * @deprecated
     * @param {?} externalErrors
     * @return {?}
     */
    function (externalErrors) {
        this.setExternalErrors(externalErrors);
        return Promise.resolve();
    };
    /**
     * @param {?} externalErrors
     * @return {?}
     */
    DynamicFormGroup.prototype.setExternalErrors = /**
     * @param {?} externalErrors
     * @return {?}
     */
    function (externalErrors) {
        this._externalErrors = externalErrors;
        return this.validate();
    };
    /**
     * @return {?}
     */
    DynamicFormGroup.prototype.getExternalErrors = /**
     * @return {?}
     */
    function () {
        return this._externalErrors;
    };
    /**
     * @deprecated
     */
    /**
     * @deprecated
     * @return {?}
     */
    DynamicFormGroup.prototype.clearExternalErrorsAsync = /**
     * @deprecated
     * @return {?}
     */
    function () {
        this.setExternalErrors({});
        return Promise.resolve();
    };
    /**
     * @return {?}
     */
    DynamicFormGroup.prototype.clearExternalErrors = /**
     * @return {?}
     */
    function () {
        this.setExternalErrors({});
    };
    /**
     * @param {?=} validatorOptions
     * @return {?}
     */
    DynamicFormGroup.prototype.setValidatorOptions = /**
     * @param {?=} validatorOptions
     * @return {?}
     */
    function (validatorOptions) {
        this._validatorOptions = (/** @type {?} */ (validatorOptions));
        this.validate();
    };
    /**
     * @return {?}
     */
    DynamicFormGroup.prototype.getValidatorOptions = /**
     * @return {?}
     */
    function () {
        return this._validatorOptions;
    };
    // Helpers
    // Helpers
    /**
     * @private
     * @param {?=} fields
     * @return {?}
     */
    DynamicFormGroup.prototype.onlyFields = 
    // Helpers
    /**
     * @private
     * @param {?=} fields
     * @return {?}
     */
    function (fields) {
        var _this = this;
        /** @type {?} */
        var newFields = {};
        if (fields !== undefined) {
            Object.keys(fields).forEach((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                if (fields[key] instanceof DynamicFormGroup) {
                    // Group: recursive
                    newFields[key] = _this.onlyFields(((/** @type {?} */ (fields[key]))).formFields);
                }
                else {
                    // Array
                    if (fields[key] instanceof FormArray) {
                        if (((/** @type {?} */ (fields[key]))).controls[0] instanceof DynamicFormGroup) {
                            // Group within Array: recursive
                            newFields[key] = _this.onlyFields(((/** @type {?} */ (((/** @type {?} */ (fields[key]))).controls[0]))).formFields);
                        }
                        else {
                            // Control within Array
                            newFields[key] = ((/** @type {?} */ (fields[key]))).controls[0].value;
                        }
                    }
                    else {
                        // Handle Control
                        newFields[key] = fields[key];
                    }
                }
            }));
        }
        return newFields;
    };
    /**
     * @private
     * @param {?} errors
     * @param {?=} controls
     * @return {?}
     */
    DynamicFormGroup.prototype.markAsInvalidForExternalErrors = /**
     * @private
     * @param {?} errors
     * @param {?=} controls
     * @return {?}
     */
    function (errors, controls) {
        /** @type {?} */
        var currentControls = controls ? controls : this.controls;
        Object.keys(currentControls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            /** @type {?} */
            var control = currentControls[field];
            // Control
            if (control instanceof FormControl) {
                if (errors && errors[field]) {
                    control.setErrors({ externalError: true });
                }
                else {
                    if (control.errors && control.errors.externalError === true) {
                        control.setErrors(null);
                    }
                }
            }
            // Group
            else if (control instanceof DynamicFormGroup) {
                control.markAsInvalidForExternalErrors(errors && errors[field] ? ((/** @type {?} */ (errors[field]))) : {});
            }
            // Array
            else if (control instanceof FormArray) {
                /** @type {?} */
                var formArrayControlsLength = ((/** @type {?} */ (control))).length;
                for (var i = 0; i < formArrayControlsLength; i++) {
                    // Control in Array
                    if (control[i] instanceof FormControl) {
                        if (errors && errors[i] && errors[i][field]) {
                            control[i].setErrors({ externalError: true });
                        }
                        else if (control[i].errors && control[i].errors.externalError === true) {
                            control[i].setErrors(null);
                        }
                    }
                    // Group in Array
                    else if (control[i] instanceof DynamicFormGroup) {
                        control[i].markAsInvalidForExternalErrors(errors && errors[i] && errors[i][field] ? ((/** @type {?} */ (errors[i][field]))) : {});
                    }
                }
            }
        }));
    };
    /**
     * Recursively gets all values from the form controls and all sub form group and array controls and returns it as
     * an object
     */
    /**
     * Recursively gets all values from the form controls and all sub form group and array controls and returns it as
     * an object
     * @private
     * @return {?}
     */
    DynamicFormGroup.prototype.getObject = /**
     * Recursively gets all values from the form controls and all sub form group and array controls and returns it as
     * an object
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        // Initialize the shape of the response
        /** @type {?} */
        var object = this._object
            ? this.classToClass(this._object)
            : this.factoryModel
                ? new this.factoryModel()
                : undefined;
        if (object !== undefined) {
            // Recursively get the value of all fields
            Object.keys(this.controls)
                .filter((/**
             * @param {?} name
             * @return {?}
             */
            function (name) { return name !== FOREVER_INVALID_NAME; }))
                .forEach((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                // Handle Group
                if (_this.controls[key] instanceof DynamicFormGroup) {
                    object[key] = ((/** @type {?} */ (_this.controls[key]))).object;
                }
                // Handle Form Array
                else if (_this.controls[key] instanceof FormArray) {
                    // Initialize value
                    object[key] = [];
                    /** @type {?} */
                    var formArrayControlsLength = ((/** @type {?} */ (_this.controls[key]))).controls.length;
                    /** @type {?} */
                    var value = void 0;
                    for (var i = 0; i < formArrayControlsLength; i++) {
                        if (((/** @type {?} */ (_this.controls[key]))).controls[i] instanceof DynamicFormGroup) {
                            // Recursively get object group
                            value = ((/** @type {?} */ (((/** @type {?} */ (_this.controls[key]))).controls[i]))).object;
                        }
                        else {
                            value = ((/** @type {?} */ (_this.controls[key]))).controls[i].value;
                        }
                        if (value && Object.keys(value).length > 0) {
                            object[key].push(value);
                        }
                    }
                    value = null;
                }
                // Handle Control
                else {
                    if (_this.controls[key]) {
                        object[key] = _this.controls[key].value;
                    }
                }
            }));
        }
        return this.factoryModel ? this.plainToClass(this.factoryModel, object) : (/** @type {?} */ (object));
    };
    /**
     * Sets the value of every control on the form and recursively sets the values of the controls
     * on all sub form groups
     *
     * @param object the data to assign to all controls of the form group and sub groups
     */
    /**
     * Sets the value of every control on the form and recursively sets the values of the controls
     * on all sub form groups
     *
     * @private
     * @param {?} object the data to assign to all controls of the form group and sub groups
     * @return {?}
     */
    DynamicFormGroup.prototype.setObject = /**
     * Sets the value of every control on the form and recursively sets the values of the controls
     * on all sub form groups
     *
     * @private
     * @param {?} object the data to assign to all controls of the form group and sub groups
     * @return {?}
     */
    function (object) {
        var _this = this;
        // console.time(String(object));
        if (object instanceof this.factoryModel) {
            this._object = this.classToClass(object); // Ensure correct type
        }
        else {
            this._object = this.plainToClass(this.factoryModel, (/** @type {?} */ (object))); // Convert to Model type
        }
        /** @type {?} */
        var newObject;
        /** @type {?} */
        var newValue;
        // Recursively set the value of all fields
        Object.keys(this.controls).forEach((/**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            // Handle Group
            if (_this.controls[key] instanceof DynamicFormGroup) {
                ((/** @type {?} */ (_this.controls[key]))).setObject(_this._object ? _this._object[key] : {});
            }
            // Handle FormArray
            else if (_this.controls[key] instanceof FormArray) {
                /** @type {?} */
                var objectArray = _this._object ? _this._object[key] : [];
                /** @type {?} */
                var formArray = (/** @type {?} */ (_this.controls[key]));
                /** @type {?} */
                var isFormGroup = formArray.controls[0] instanceof DynamicFormGroup;
                /** @type {?} */
                var firstFormGroup = (/** @type {?} */ (formArray.controls[0]));
                /** @type {?} */
                var formControl = (/** @type {?} */ (formArray.controls[0]));
                // Clear FormArray while retaining the reference
                /** @type {?} */
                var objectArrayLength = objectArray.length;
                /** @type {?} */
                var dynamicFormGroup_1;
                /** @type {?} */
                var controlValue = void 0;
                /** @type {?} */
                var newFormControl = void 0;
                /** @type {?} */
                var classValidators = void 0;
                /** @type {?} */
                var formGroup_1;
                /** @type {?} */
                var formArrayLength = formArray.length;
                for (var i = 0; i < formArrayLength; i++) {
                    if (formArray.controls[i] instanceof DynamicFormGroup &&
                        ((/** @type {?} */ (formArray.controls[i]))).valueChangesSubscription) {
                        ((/** @type {?} */ (formArray.controls[i]))).valueChangesSubscription.unsubscribe();
                    }
                }
                while (formArrayLength !== 0) {
                    formArray.removeAt(0);
                    formArrayLength--;
                }
                formArrayLength = null;
                for (var i = 0; i < objectArrayLength; i++) {
                    if (isFormGroup) {
                        // Create FormGroup
                        dynamicFormGroup_1 = new DynamicFormGroup(firstFormGroup.factoryModel, firstFormGroup.formFields);
                        dynamicFormGroup_1.setParent(formArray);
                        formGroup_1 = _this._fb.group(getClassValidators(firstFormGroup.factoryModel, firstFormGroup.formFields));
                        // Add all controls to the form group
                        Object.keys(formGroup_1.controls).forEach((/**
                         * @param {?} ctrlKey
                         * @return {?}
                         */
                        function (ctrlKey) {
                            dynamicFormGroup_1.addControl(ctrlKey, formGroup_1.controls[ctrlKey]);
                        }));
                        formArray.controls.push(dynamicFormGroup_1);
                    }
                    else {
                        // Create control
                        controlValue = _this._object && objectArray && objectArray[i] ? objectArray[i] : undefined;
                        newFormControl = new FormControl(controlValue, formControl ? formControl.validator : undefined);
                        newFormControl.setParent(formArray);
                        // Add the control to the FormArray
                        formArray.controls.push(newFormControl);
                    }
                }
                /** @type {?} */
                var arrayLength = formArray.length;
                for (var i = 0; i < arrayLength; i++) {
                    if (isFormGroup) {
                        // Add a value change listener to the group. on change, validate
                        if (formArray.controls[i] instanceof DynamicFormGroup) {
                            // Recusrively set the object value
                            ((/** @type {?} */ (formArray.controls[i]))).object =
                                _this._object && objectArray && objectArray[i] ? objectArray[i] : {};
                        }
                    }
                }
                for (var i = 0; i < arrayLength; i++) {
                    if (isFormGroup) {
                        // Add a value change listener to the group. on change, validate
                        if (formArray.controls[i] instanceof DynamicFormGroup) {
                            ((/** @type {?} */ (formArray.controls[i]))).subscribeToValueChanges(undefined, _this._validatorOptions);
                        }
                    }
                }
                classValidators = null;
                formGroup_1 = null;
                controlValue = null;
                newFormControl = null;
                dynamicFormGroup_1 = null;
                objectArrayLength = null;
                arrayLength = null;
                objectArray = null;
                formArray = null;
                isFormGroup = null;
                firstFormGroup = null;
                formControl = null;
            }
            // Handle Control
            else {
                newObject = _this._object ? _this._object[key] : [];
                newValue = _this._object && newObject ? newObject : undefined;
                if (_this.controls[key].value !== newValue) {
                    _this.controls[key].setValue(newValue);
                }
            }
        }));
        newValue = null;
        newObject = null;
        this.objectChange.next(this._object);
        // console.timeEnd(String(object));
    };
    return DynamicFormGroup;
}(FormGroup));
if (false) {
    /** @type {?} */
    DynamicFormGroup.prototype.nativeValidateErrors;
    /** @type {?} */
    DynamicFormGroup.prototype.customValidateErrors;
    /** @type {?} */
    DynamicFormGroup.prototype.formErrors;
    /** @type {?} */
    DynamicFormGroup.prototype.formFields;
    /** @type {?} */
    DynamicFormGroup.prototype.objectChange;
    /** @type {?} */
    DynamicFormGroup.prototype.valueChangesSubscription;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._object;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._externalErrors;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._validatorOptions;
    /**
     * @type {?}
     * @private
     */
    DynamicFormGroup.prototype._fb;
    /** @type {?} */
    DynamicFormGroup.prototype.factoryModel;
    /** @type {?} */
    DynamicFormGroup.prototype.fields;
}
/**
 * @template TModel
 * @param {?} factoryModel
 * @param {?=} fields
 * @param {?=} validatorOptions
 * @return {?}
 */
function getClassValidators(factoryModel, fields, validatorOptions) {
    // console.time(String(factoryModel));
    // Get the validation rules from the object decorators
    /** @type {?} */
    var allValidationMetadatas = getMetadataStorage().getTargetValidationMetadatas(factoryModel, '');
    // Get the validation rules for the validation group: https://github.com/typestack/class-validator#validation-groups
    /** @type {?} */
    var validationGroupMetadatas = getMetadataStorage().getTargetValidationMetadatas(factoryModel, '', validatorOptions && validatorOptions.groups ? validatorOptions.groups : undefined);
    /** @type {?} */
    var formGroupFields = {};
    // Loop through all fields in the form definition
    if (fields) {
        /** @type {?} */
        var conditionalValidations_1;
        /** @type {?} */
        var allNestedValidations_1;
        /** @type {?} */
        var nestedGroupValidations_1;
        /** @type {?} */
        var fieldDefinition_1;
        /** @type {?} */
        var dynamicValidate_1;
        /** @type {?} */
        var customValidation_1;
        /** @type {?} */
        var objectToValidate_1;
        /** @type {?} */
        var nestedValidate_1;
        Object.keys(fields)
            .filter((/**
         * @param {?} key
         * @return {?}
         */
        function (key) { return key.indexOf('__') !== 0; }))
            .forEach((/**
         * @param {?} fieldName
         * @return {?}
         */
        function (fieldName) {
            // Conditional Validation for the field
            conditionalValidations_1 = [];
            validationGroupMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            function (validationMetadata) {
                if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.conditional.type)) {
                    conditionalValidations_1.push(validationMetadata);
                }
            }));
            // All Nested Validation for the field
            allNestedValidations_1 = [];
            allValidationMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            function (validationMetadata) {
                if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.nested.type)) {
                    allNestedValidations_1.push(validationMetadata);
                }
            }));
            // Nested Validation for the field for the requested class-validator group
            nestedGroupValidations_1 = [];
            validationGroupMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            function (validationMetadata) {
                if (isPropertyValidatorOfType(validationMetadata, fieldName, ValidationKeys.nested.type)) {
                    nestedGroupValidations_1.push(validationMetadata);
                }
            }));
            fieldDefinition_1 = {
                data: formGroupFields[fieldName] || undefined,
                validationFunctions: [],
                validationDefinitions: [],
            };
            if (fieldDefinition_1.data === undefined) {
                fieldDefinition_1.data = fields[fieldName];
            }
            // TRY LINK EXISTS NATIVE VALIDATIONS, UNSTABLE !!!
            if (Array.isArray(fieldDefinition_1.data) &&
                fieldDefinition_1.data.length > 1 &&
                fieldDefinition_1.data.find((/**
                 * @param {?} validationFunction
                 * @param {?} index
                 * @return {?}
                 */
                function (validationFunction, index) { return index > 0 && typeof validationFunction === 'function'; }))) {
                fieldDefinition_1.data
                    .filter((/**
                 * @param {?} validationFunction
                 * @param {?} index
                 * @return {?}
                 */
                function (validationFunction, index) { return index > 0 && typeof validationFunction === 'function'; }))
                    .forEach((/**
                 * @param {?} validationFunction
                 * @return {?}
                 */
                function (validationFunction) {
                    return fieldDefinition_1.validationFunctions.push({ type: 'sync', validator: validationFunction });
                }));
                fieldDefinition_1.data = fieldDefinition_1.data[0];
            }
            validationGroupMetadatas.forEach((/**
             * @param {?} validationMetadata
             * @return {?}
             */
            function (validationMetadata) {
                if (validationMetadata.propertyName === fieldName &&
                    validationMetadata.type !== ValidationKeys.conditional.type) {
                    // Add all validation to the field except the @NestedValidation definition as
                    // being part of the form would imply it is validated if any other rules are present
                    if (validationMetadata.type !== ValidationKeys.nested.type) {
                        fieldDefinition_1.validationDefinitions.push(validationMetadata);
                    }
                    Object.keys(ValidationTypes).forEach((/**
                     * @param {?} typeKey
                     * @return {?}
                     */
                    function (typeKey) {
                        if (ValidationTypes.hasOwnProperty(typeKey)) {
                            // Handle Nested Validation
                            if (checkWithAllNestedValidations(allNestedValidations_1, nestedGroupValidations_1, fieldName)) {
                                if (isNestedValidate(validationMetadata, typeKey)) {
                                    objectToValidate_1 =
                                        fields[fieldName] instanceof DynamicFormGroup ? fields[fieldName].object : undefined;
                                    nestedValidate_1 = createNestedValidate(fieldName, objectToValidate_1, validationMetadata);
                                    setFieldData(fieldName, fieldDefinition_1, nestedValidate_1);
                                    objectToValidate_1 = null;
                                    nestedValidate_1 = null;
                                }
                            }
                            // Handle Custom Validation
                            if (isCustomValidate(validationMetadata, typeKey)) {
                                customValidation_1 = createCustomValidation(fieldName, validationMetadata);
                                setFieldData(fieldName, fieldDefinition_1, customValidation_1);
                                customValidation_1 = null;
                            }
                            // Handle remaining validation
                            if (isDynamicValidate(validationMetadata, typeKey)) {
                                dynamicValidate_1 = createDynamicValidate(fieldName, validationMetadata, conditionalValidations_1);
                                setFieldData(fieldName, fieldDefinition_1, dynamicValidate_1);
                                dynamicValidate_1 = null;
                            }
                        }
                    }));
                }
            }));
            // Convert to a structure, angular understands
            if (fieldDefinition_1.data instanceof DynamicFormGroup || fieldDefinition_1.data instanceof FormArray) {
                formGroupFields[fieldName] = fieldDefinition_1.data;
            }
            else {
                formGroupFields[fieldName] = new DynamicFormControl(fieldName, fieldDefinition_1);
            }
        }));
        dynamicValidate_1 = null;
        customValidation_1 = null;
        objectToValidate_1 = null;
        nestedValidate_1 = null;
        conditionalValidations_1 = null;
        allNestedValidations_1 = null;
        nestedGroupValidations_1 = null;
        fieldDefinition_1 = null;
    }
    allValidationMetadatas = null;
    validationGroupMetadatas = null;
    // console.timeEnd(String(factoryModel));
    return formGroupFields;
    // ******************************************************************************************
    // Local Helper functions to help make the main code more readable
    //
    /**
     * @param {?} fieldName
     * @param {?} objectToValidate
     * @param {?} validationMetadata
     * @return {?}
     */
    function createNestedValidate(fieldName, objectToValidate, validationMetadata) {
        return {
            type: 'sync',
            validator: (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var parent = control.parent;
                /** @type {?} */
                var validateErrors = (parent &&
                    parent.value &&
                    getValidateErrors(parent, objectToValidate !== undefined ? objectToValidate : control.value, validatorOptions)) ||
                    {};
                /** @type {?} */
                var validateState = Object.keys(validateErrors).length === 0;
                /** @type {?} */
                var result = getIsValidResult(validateState, validationMetadata, 'nestedValidate');
                parent = null;
                validateErrors = null;
                validateState = null;
                return result;
            }),
        };
    }
    /**
     * @param {?} fieldName
     * @param {?} validationMetadata
     * @param {?} conditionalValidations
     * @return {?}
     */
    function createDynamicValidate(fieldName, validationMetadata, conditionalValidations) {
        return {
            type: 'sync',
            validator: (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                if (!control) {
                    return null;
                }
                /** @type {?} */
                var validateErrors = setObjectValueAndGetValidationErrors(fieldName, control, validatorOptions);
                /** @type {?} */
                var validateState = getAllErrors(validateErrors, fieldName).length === 0;
                /** @type {?} */
                var result = getIsValidResult(validateState, validationMetadata, 'dynamicValidate');
                validateErrors = null;
                validateState = null;
                return result;
            }),
        };
    }
    /**
     * @param {?} fieldName
     * @param {?} validationMetadata
     * @return {?}
     */
    function createCustomValidation(fieldName, validationMetadata) {
        return {
            type: 'sync',
            validator: (/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var validateErrors = setObjectValueAndGetValidationErrors(fieldName, control, validatorOptions);
                /** @type {?} */
                var validateState = validateErrors && validateErrors[fieldName] ? false : true;
                /** @type {?} */
                var result = getIsValidResult(validateState, validationMetadata, 'customValidation');
                validateErrors = null;
                validateState = null;
                return result;
            }),
        };
    }
    /**
     * @param {?} allNestedValidations
     * @param {?} nestedValidations
     * @param {?} key
     * @return {?}
     */
    function checkWithAllNestedValidations(allNestedValidations, nestedValidations, key) {
        /** @type {?} */
        var allNestedValidationsLength = allNestedValidations.length;
        /** @type {?} */
        var nestedValidationsLength = nestedValidations.length;
        return (allNestedValidationsLength === nestedValidationsLength ||
            (((fields && fields[key] instanceof DynamicFormGroup) || (fields && fields[key] instanceof FormArray)) &&
                allNestedValidationsLength > 0 &&
                nestedValidationsLength === 0));
    }
    /**
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isDynamicValidate(validationMetadata, typeKey) {
        return validationMetadata.type === ValidationTypes[typeKey] && validator[validationMetadata.type] !== undefined;
    }
    /**
     * marked with \@Validate(...)
     * https://github.com/typestack/class-validator#custom-validation-classes
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isCustomValidate(validationMetadata, typeKey) {
        return (isNotPropertyValidation(validationMetadata, typeKey) &&
            validationMetadata.type === ValidationKeys.custom.type &&
            typeKey === ValidationKeys.custom.typeKey);
    }
    /**
     * marked with \@ValidateNested()
     * https://github.com/typestack/class-validator#validating-nested-objects
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isNestedValidate(validationMetadata, typeKey) {
        return (isNotPropertyValidation(validationMetadata, typeKey) &&
            validationMetadata.type === ValidationKeys.nested.type &&
            typeKey === ValidationKeys.nested.typeKey);
    }
    /**
     * @param {?} validationMetadata
     * @param {?} typeKey
     * @return {?}
     */
    function isNotPropertyValidation(validationMetadata, typeKey) {
        return validationMetadata.type === ValidationTypes[typeKey] && validator[validationMetadata.type] === undefined;
    }
    /**
     * @param {?} fieldName
     * @param {?} fieldDefinition
     * @param {?} validationFunction
     * @return {?}
     */
    function setFieldData(fieldName, fieldDefinition, validationFunction) {
        /* todo: maybe not need, if enable this code, experemental mode not work
        if (fields[fieldName] instanceof DynamicFormGroup) {
          fields[fieldName].object = fields[fieldName].fields;
        }*/
        // Fill field data if empty
        if (fieldDefinition.data === undefined) {
            fieldDefinition.data = fields && fields[fieldName];
        }
        fieldDefinition.validationFunctions.push(validationFunction);
    }
    /**
     * @param {?} validateErrors
     * @param {?} fieldName
     * @return {?}
     */
    function getAllErrors(validateErrors, fieldName) {
        return Object.keys(validateErrors).filter((/**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            // Check for nested/child errors
            return validateErrors[key][fieldName] || validateErrors[fieldName];
        }));
    }
}
// ***************************************************************
// Global Helper functions
//
/**
 * @param {?} validationMetadata
 * @param {?} fieldName
 * @param {?} validationMetadataType
 * @return {?}
 */
function isPropertyValidatorOfType(validationMetadata, fieldName, validationMetadataType) {
    return validationMetadata.propertyName === fieldName && validationMetadata.type === validationMetadataType;
}
/**
 * @param {?} fieldName
 * @param {?} control
 * @param {?=} validatorOptions
 * @return {?}
 */
function setObjectValueAndGetValidationErrors(fieldName, control, validatorOptions) {
    /** @type {?} */
    var parent = control.parent instanceof DynamicFormGroup
        ? ((/** @type {?} */ (control.parent)))
        : control.parent
            ? control.parent
            : null;
    /** @type {?} */
    var object = control.parent instanceof DynamicFormGroup
        ? ((/** @type {?} */ (control.parent))).object
        : control.parent
            ? control.parent.value
            : {};
    if (object) {
        object[fieldName] = control.value;
    }
    /** @type {?} */
    var result = (parent && parent.value && getValidateErrors(parent, object, validatorOptions)) || {};
    parent = null;
    object = null;
    return result;
}
/**
 * @template T
 * @param {?} control
 * @param {?} dataToValidate
 * @param {?=} validatorOptions
 * @return {?}
 */
function getValidateErrors(control, dataToValidate, validatorOptions) {
    /** @type {?} */
    var validateKey = safeStringify({ dataToValidate: dataToValidate, validatorOptions: validatorOptions });
    /** @type {?} */
    var ctrl = ((/** @type {?} */ (control))) || {};
    /** @type {?} */
    var validatedErrors;
    if (ctrl.__prevValidateKey === validateKey && ctrl.__prevValidateErrors !== undefined) {
        // console.log('CACHED', validateKey);
        validatedErrors = ctrl.__prevValidateErrors;
    }
    else {
        // console.log('NO CACHED', validateKey);
        validatedErrors = transformValidationErrors(validateSync(dataToValidate, validatorOptions));
        ctrl.__prevValidateErrors = validatedErrors;
        ctrl.__prevValidateKey = validateKey;
    }
    validateKey = null;
    ctrl = null;
    return validatedErrors;
}
/**
 * @param {?} isValid
 * @param {?} validationMetadata
 * @param {?} errorType
 * @return {?}
 */
function getIsValidResult(isValid, validationMetadata, errorType) {
    var _a;
    return isValid
        ? null
        : (_a = {},
            _a[errorType] = {
                valid: false,
                type: validationMetadata.type,
            },
            _a);
}
/** @type {?} */
var ValidationKeys = {
    nested: {
        type: 'nestedValidation',
        typeKey: 'NESTED_VALIDATION',
    },
    conditional: {
        type: 'conditionalValidation',
    },
    custom: {
        type: 'customValidation',
        typeKey: 'CUSTOM_VALIDATION',
    },
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/utils/dynamic-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DynamicFormBuilder = /** @class */ (function (_super) {
    __extends(DynamicFormBuilder, _super);
    function DynamicFormBuilder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // ******************
    // Public API
    // ******************
    // Public API
    /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} controlsConfig
     * @param {?=} options
     * @return {?}
     */
    DynamicFormBuilder.prototype.group = 
    // ******************
    // Public API
    /**
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} controlsConfig
     * @param {?=} options
     * @return {?}
     */
    function (factoryModel, controlsConfig, options) {
        var _this = this;
        // console.time(factoryModel.toString());
        if (!controlsConfig && !options) {
            options = {};
        }
        // Process the group with the controlsConfig passed into extra instead. (What does this accomplish?)
        if (controlsConfig &&
            (isAbstractControlOptions(controlsConfig) ||
                isLegacyOrOpts(controlsConfig) ||
                isDynamicFormGroupConfig(controlsConfig)) &&
            !options) {
            return this.group(factoryModel, undefined, controlsConfig);
        }
        /** @type {?} */
        var extra = (/** @type {?} */ (options));
        /** @type {?} */
        var validators = null;
        /** @type {?} */
        var asyncValidators = null;
        /** @type {?} */
        var updateOn;
        if (extra != null) {
            if (isAbstractControlOptions(extra)) {
                // `extra` are `AbstractControlOptions`
                validators = extra.validators != null ? extra.validators : null;
                asyncValidators = extra.asyncValidators != null ? extra.asyncValidators : null;
                updateOn = extra.updateOn != null ? extra.updateOn : undefined;
            }
            if (isLegacyOrOpts(extra)) {
                // `extra` are legacy form group options
                validators = validators || [];
                if (extra.validator != null) {
                    validators.push(extra.validator);
                }
                asyncValidators = asyncValidators || [];
                if (extra.asyncValidator != null) {
                    asyncValidators.push(extra.asyncValidator);
                }
            }
            // Set default customValidatorOptions
            if (!isDynamicFormGroupConfig(extra)) {
                extra.customValidatorOptions = { validationError: { target: false } };
            }
        }
        /** @type {?} */
        var newControlsConfig;
        if (controlsConfig !== undefined) {
            newControlsConfig = (/** @type {?} */ (controlsConfig));
        }
        // experimental
        if (controlsConfig === undefined) {
            newControlsConfig = __assign({}, this.createEmptyObject(factoryModel));
            if (newControlsConfig !== undefined) {
                Object.keys(newControlsConfig).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) {
                    if (canCreateGroup() && newControlsConfig) {
                        // recursively create a dynamic group for the nested object
                        newControlsConfig[key] = _this.group(newControlsConfig[key].constructor, undefined, __assign(__assign({}, (extra.customValidatorOptions ? { customValidatorOptions: extra.customValidatorOptions } : {})), { asyncValidators: asyncValidators,
                            updateOn: updateOn,
                            validators: validators }));
                    }
                    else {
                        if (canCreateArray() && newControlsConfig) {
                            if (newControlsConfig[key][0].constructor) {
                                // recursively create an array with a group
                                newControlsConfig[key] = _super.prototype.array.call(_this, newControlsConfig[key].map((/**
                                 * @param {?} newControlsConfigItem
                                 * @return {?}
                                 */
                                function (newControlsConfigItem) {
                                    return _this.group(newControlsConfigItem.constructor, undefined, __assign(__assign({}, (extra.customValidatorOptions ? { customValidatorOptions: extra.customValidatorOptions } : {})), { asyncValidators: asyncValidators,
                                        updateOn: updateOn,
                                        validators: validators }));
                                })));
                            }
                            else {
                                // Create an array of form controls
                                newControlsConfig[key] = _super.prototype.array.call(_this, newControlsConfig[key].map((/**
                                 * @param {?} newControlsConfigItem
                                 * @return {?}
                                 */
                                function (newControlsConfigItem) { return _this.control(newControlsConfigItem); })));
                            }
                        }
                    }
                    /**
                     * @return {?}
                     */
                    function canCreateGroup() {
                        /** @type {?} */
                        var candidate = newControlsConfig && newControlsConfig[key];
                        return (candidate &&
                            !Array.isArray(candidate) &&
                            candidate.constructor &&
                            typeof candidate === 'object' &&
                            (candidate.length === undefined ||
                                (candidate.length !== undefined && Object.keys(candidate).length === candidate.length)));
                    }
                    /**
                     * @return {?}
                     */
                    function canCreateArray() {
                        if (Array.isArray(newControlsConfig && newControlsConfig[key]) === false) {
                            return false;
                        }
                        /** @type {?} */
                        var candidate = newControlsConfig && newControlsConfig[key][0];
                        return (candidate.constructor &&
                            typeof candidate === 'object' &&
                            (candidate.length === undefined ||
                                (candidate.length !== undefined && Object.keys(candidate).length === candidate.length)));
                    }
                }));
            }
        }
        // Remove empty
        validators = validators && validators.filter((/**
         * @param {?} validator
         * @return {?}
         */
        function (validator) { return validator; }));
        asyncValidators = asyncValidators && asyncValidators.filter((/**
         * @param {?} validator
         * @return {?}
         */
        function (validator) { return validator; }));
        // Create an Angular group from the top-level object
        /** @type {?} */
        var classValidators = getClassValidators(factoryModel, newControlsConfig, extra && extra.customValidatorOptions);
        /** @type {?} */
        var formGroup = _super.prototype.group.call(this, classValidators, __assign(__assign(__assign({}, (asyncValidators || {})), (updateOn || {})), (validators || {})));
        // Initialize the resulting group
        /** @type {?} */
        var dynamicFormGroup = new DynamicFormGroup(factoryModel, newControlsConfig, {
            asyncValidators: asyncValidators,
            updateOn: updateOn,
            validators: validators,
        });
        // Add all angular controls to the resulting dynamic group
        Object.keys(formGroup.controls).forEach((/**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            dynamicFormGroup.addControl(key, formGroup.controls[key]);
        }));
        // Add a listener to the dynamic group for value changes; on change, execute validation
        dynamicFormGroup.subscribeToValueChanges(undefined, extra && extra.customValidatorOptions);
        classValidators = null;
        formGroup = null;
        // console.timeEnd(factoryModel.toString());
        return dynamicFormGroup;
    };
    // *******************
    // Helpers
    /**
     * Recursively creates an empty object from the data provided
     */
    // *******************
    // Helpers
    /**
     * Recursively creates an empty object from the data provided
     * @private
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} data
     * @return {?}
     */
    DynamicFormBuilder.prototype.createEmptyObject = 
    // *******************
    // Helpers
    /**
     * Recursively creates an empty object from the data provided
     * @private
     * @template TModel
     * @param {?} factoryModel
     * @param {?=} data
     * @return {?}
     */
    function (factoryModel, data) {
        var _this = this;
        if (data === void 0) { data = {}; }
        /** @type {?} */
        var modifed = false;
        /** @type {?} */
        var object = factoryModel ? plainToClass(factoryModel, data) : data;
        /** @type {?} */
        var fields = Object.keys(object);
        /** @type {?} */
        var objectFieldNameLength;
        /** @type {?} */
        var objectFieldName0;
        fields.forEach((/**
         * @param {?} fieldName
         * @return {?}
         */
        function (fieldName) {
            objectFieldNameLength = object[fieldName] && object[fieldName].length;
            if (objectFieldNameLength !== undefined) {
                objectFieldName0 = object[fieldName][0];
                if (objectFieldNameLength === 1 && Object.keys(objectFieldName0).length > 0 && objectFieldName0.constructor) {
                    object[fieldName] = [_this.createEmptyObject(objectFieldName0.constructor)];
                }
                if (objectFieldNameLength === 0) {
                    data[fieldName] = [{}];
                    modifed = true;
                }
            }
            else {
                data[fieldName] = undefined;
            }
        }));
        if (modifed) {
            object = null;
            fields = null;
            return this.createEmptyObject(factoryModel, data);
        }
        fields = null;
        return object;
    };
    return DynamicFormBuilder;
}(FormBuilder));

/**
 * @fileoverview added by tsickle
 * Generated from: index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-dynamic-form-builder.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DynamicFormBuilder, DynamicFormControl, DynamicFormGroup, FOREVER_INVALID_NAME, foreverInvalid, getClassValidators, isAbstractControlOptions, isDynamicFormGroupConfig, isLegacyOrOpts, mergeErrors, transformValidationErrors };
//# sourceMappingURL=ngx-dynamic-form-builder.js.map
